﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Globalization;
using System.Xml;

namespace WpfXamMaskedEditBindingTest
{
	public static class TypeConvertUtils
	{
		public static decimal? ToNullableDecimal(object o)
		{
			return _ToNullableDecimal(o);
		}

		private static decimal? _ToNullableDecimal(object o)
		{
			decimal? retVal = null;
			if( o == DBNull.Value )
			{
				//	Do nothing
			}
			else if( o == null )
			{
				//	Do nothing
			}
			else if( o is decimal )
			{
				retVal = o as decimal?;
			}
			else if( o is long )
			{
				retVal = new decimal((long)o);
			}
			else if( o is int )
			{
				retVal = new decimal((int)o);
			}
			else if( o is double )
			{
				retVal = new decimal((double)o);
			}
			else if( o is string )
			{
				string temp = o as string;

				if( !string.IsNullOrEmpty(temp) )
				{
					try
					{
						retVal = decimal.Parse(temp, NumberStyles.Any);
					}
					catch( Exception )
					{
						retVal = null;
					}
				}
			}
			return retVal;
		}

		public static string ToString(object o)
		{
			string retVal = null;
			if( o == DBNull.Value || o == null )
			{
			}
			else if( o is string )
			{
				retVal = o as string;
			}
			else
			{
				retVal = o.ToString();
			}
			return retVal;
		}

	}
}
