﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Diagnostics;
using Infragistics.Windows.Editors;

namespace WpfXamMaskedEditBindingTest
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		private Foo _foo;
		public Window1()
		{
			InitializeComponent();
		}

		private void Window_Loaded(object sender, RoutedEventArgs e)
		{
			_Reload();
		}

		private void _FormatEditor(XamMaskedEditor editor)
		{
			editor.ValueType = typeof(string); // IG: use string instead of decimal
			editor.Mask = "{LOC}999:99:99";
			editor.PadChar = '0';
			editor.DataMode = MaskMode.IncludeLiteralsWithPadding;
			editor.DisplayMode = MaskMode.IncludeLiteralsWithPadding;
			editor.InsertMode = false;

			// IG: don't set any converters on the editor. instead set them on the binding
			// that binds the editor's Value to data source, which we do in _Reaload method.
			//editor.ValueToDisplayTextConverter = new XamDurationConverter();
			//editor.ValueToTextConverter = new XamDurationConverter();
			return;
		}

		private void _Reload()
		{
			this._foo = new Foo();

			this._FormatEditor(this.inpDuration);

			this.DataContext = this._foo;
			BindingOperations.SetBinding(
				this.inpDuration,
				XamMaskedEditor.ValueProperty,
				//IG: specify the converter here instead of the editors.
				new Binding("Value") { Mode = BindingMode.TwoWay, Converter = new XamDurationConverter( ) });

			BindingOperations.SetBinding(
				this.inpRaw,
				TextBlock.TextProperty,
				new Binding("Value") { Mode = BindingMode.OneWay });
			return;
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			_Reload();
		}

		private void Button_Click_1(object sender, RoutedEventArgs e)
		{
			this._foo.Value = new decimal(100);
		}
	}

	public class Foo : INotifyPropertyChanged
	{
		private object _value;
		public object Value
		{
			get { return _value; }
			set
			{
				_value = value;
				this._RaisePropertyChanged("Value");
				if( this._value == null )
				{
					this._dataTypeName = "null";
				}
				else
				{
					this._dataTypeName = this._value.GetType().FullName;
				}
				this._RaisePropertyChanged("DataTypeName");
			}
		}

		private string _dataTypeName;
		public string DataTypeName
		{
			[DebuggerStepThrough]
			get { return _dataTypeName; }
		}



		public event PropertyChangedEventHandler PropertyChanged;

		private void _RaisePropertyChanged(string propertyName)
		{
			PropertyChangedEventHandler dlg = this.PropertyChanged;
			if( dlg != null )
			{
				dlg.Invoke(this, new PropertyChangedEventArgs(propertyName));
			}
			return;
		}

	}
}
